diff -ruN ../nakedmudv3.1/src/scripts/pymudsys.c src/scripts/pymudsys.c
--- ../nakedmudv3.1/src/scripts/pymudsys.c	Wed Dec 31 17:00:00 1969
+++ src/scripts/pymudsys.c	Sat Jul  1 20:06:58 2006
@@ -0,0 +1,254 @@
+//*****************************************************************************
+//
+// pymudsys.c
+//
+// A set of system level commands and variables that may be needed by python,
+// but which are not neccessarily needed by scripts.
+//
+//*****************************************************************************
+#include <Python.h>
+#include <structmember.h>
+
+#include "../mud.h"
+#include "../utils.h"
+#include "../character.h"
+#include "../socket.h"
+#include "../save.h"
+
+#include "pymudsys.h"
+#include "scripts.h"
+#include "pyplugs.h"
+#include "pychar.h"
+
+
+
+//*****************************************************************************
+// local variables and functions
+//*****************************************************************************
+// a list of methods to add to the mudsys module
+LIST *pymudsys_methods = NULL;
+
+
+
+//*****************************************************************************
+// mudsys methods
+//*****************************************************************************
+PyObject *mudsys_set_sys_val(PyObject *self, PyObject *args) {
+  char *key, *val;
+  if(!PyArg_ParseTuple(args, "ss", &key, &val)) {
+    PyErr_Format(PyExc_TypeError, "Provide a string key and value");
+    return NULL;
+  }
+
+  mudsettingSetString(key, val);
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *mudsys_get_sys_val(PyObject *self, PyObject *args) {
+  char *key;
+  if(!PyArg_ParseTuple(args, "s", &key)) {
+    PyErr_Format(PyExc_TypeError, "Provide a string key");
+    return NULL;
+  }
+
+  return Py_BuildValue("s", mudsettingGetString(key));
+}
+
+PyObject *mudsys_shutdown(PyObject *self, PyObject *args) {
+  shut_down = TRUE;
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *mudsys_copyover(PyObject *self, PyObject *args) {
+  do_copyover();
+  return Py_BuildValue("i", 1);
+}
+
+//
+// saves a player to disk
+PyObject *mudsys_do_save(PyObject *self, PyObject *args) {
+  PyObject *pych = NULL;
+  CHAR_DATA  *ch = NULL;
+
+  if(!PyArg_ParseTuple(args, "O", &pych)) {
+    PyErr_Format(PyExc_TypeError, "A character to be saved must be supplied.");
+    return NULL;
+  }
+
+  if(!PyChar_Check(pych)) {
+    PyErr_Format(PyExc_TypeError, "Only characters may be saved.");
+    return NULL;
+  }
+
+  if( (ch = PyChar_AsChar(pych)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to save nonexistant character, %d.",PyChar_AsUid(pych));
+    return NULL;
+  }
+
+  if(!charIsNPC(ch))
+    save_player(ch);
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// quits a character from the game
+PyObject *mudsys_do_quit(PyObject *self, PyObject *args) {
+  PyObject *pych = NULL;
+  CHAR_DATA  *ch = NULL;
+
+  if(!PyArg_ParseTuple(args, "O", &pych)) {
+    PyErr_Format(PyExc_TypeError,"A character to be quitted must be supplied.");
+    return NULL;
+  }
+
+  if(!PyChar_Check(pych)) {
+    PyErr_Format(PyExc_TypeError, "Only characters may be quitted.");
+    return NULL;
+  }
+
+  if( (ch = PyChar_AsChar(pych)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to quit nonexistant character, %d.",PyChar_AsUid(pych));
+    return NULL;
+  }
+
+  if(!charIsNPC(ch) && charGetSocket(ch)) {
+    SOCKET_DATA *sock = charGetSocket(ch);
+    charSetSocket(ch, NULL);
+    socketSetChar(sock, NULL);
+    socketPopInputHandler(sock);
+    extract_mobile(ch);
+  }
+
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// disconnects a character from its socket
+PyObject *mudsys_do_disconnect(PyObject *self, PyObject *args) {
+  PyObject *pych = NULL;
+  CHAR_DATA  *ch = NULL;
+
+  if(!PyArg_ParseTuple(args, "O", &pych)) {
+    PyErr_Format(PyExc_TypeError,"A character to be dc'd must be supplied.");
+    return NULL;
+  }
+
+  if(!PyChar_Check(pych)) {
+    PyErr_Format(PyExc_TypeError, "Only characters may be dc'd.");
+    return NULL;
+  }
+
+  if( (ch = PyChar_AsChar(pych)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to dc nonexistant character, %d.",PyChar_AsUid(pych));
+    return NULL;
+  }
+
+  if(charGetSocket(ch)) {
+    SOCKET_DATA *sock = charGetSocket(ch);
+    charSetSocket(ch, NULL);
+    socketSetChar(sock, NULL);
+    close_socket(sock, FALSE);
+  }
+
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// add a new command to the mud, via a python script or module. Takes in a
+// command name, a sort_by command, the function, a minimum and maximum 
+// position in the form of strings, a level, and boolean values for whether the
+// command can be performed by mobiles, and whether it interrupts actions.
+PyObject *mudsys_add_cmd(PyObject *self, PyObject *args) {
+  PyObject *func = NULL;
+  char *name  = NULL, *sort_by = NULL, *min_pos = NULL, *max_pos = NULL,
+       *group = NULL;
+  bool mob_ok = FALSE, interrupts = FALSE;
+  int min_pos_num, max_pos_num;
+
+  // parse all of the values
+  if (!PyArg_ParseTuple(args, "szOsssbb", &name, &sort_by, &func,
+  			&min_pos, &max_pos, &group, &mob_ok, &interrupts)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Could not add new command. Improper arguments supplied");
+    return NULL;
+  }
+
+  // get our positions
+  min_pos_num = posGetNum(min_pos);
+  max_pos_num = posGetNum(max_pos);
+  if(min_pos_num == POS_NONE || max_pos_num == POS_NONE) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Could not add new command. Invalid position names.");
+    return NULL;
+  }
+
+  // add the command to the game
+  add_py_cmd(name, sort_by, func, min_pos_num, max_pos_num,
+	     group, mob_ok, interrupts);
+  return Py_None;
+}
+
+
+//
+// removes a command from the game
+PyObject *mudsys_remove_cmd(PyObject *self, PyObject *args) {
+  char *name = NULL;
+  // parse all of the values
+  if (!PyArg_ParseTuple(args, "s", &name)) {
+    PyErr_Format(PyExc_TypeError, "function requires string argument.");
+    return NULL;
+  }
+  remove_cmd(name);
+  return Py_None;
+}
+
+
+
+//*****************************************************************************
+// MudSys module
+//*****************************************************************************
+void PyMudSys_addMethod(const char *name, void *f, int flags, const char *doc) {
+  // make sure our list of methods is created
+  if(pymudsys_methods == NULL) pymudsys_methods = newList();
+
+  // make the Method def
+  PyMethodDef *def = calloc(1, sizeof(PyMethodDef));
+  def->ml_name     = strdup(name);
+  def->ml_meth     = (PyCFunction)f;
+  def->ml_flags    = flags;
+  def->ml_doc      = (doc ? strdup(doc) : NULL);
+  listPut(pymudsys_methods, def);
+}
+
+
+PyMODINIT_FUNC
+init_PyMudSys(void) {
+  // add all of our methods
+  PyMudSys_addMethod("do_shutdown", mudsys_shutdown, METH_VARARGS,
+		     "shuts the mud down.");
+  PyMudSys_addMethod("do_copyover", mudsys_copyover, METH_VARARGS,
+		     "performs a copyover on the mud.");
+  PyMudSys_addMethod("sys_setval", mudsys_set_sys_val, METH_VARARGS,
+		     "sets a system value on the mud.");
+  PyMudSys_addMethod("sys_getval", mudsys_get_sys_val, METH_VARARGS,
+		     "returns a system value on the mud.");
+  PyMudSys_addMethod("do_save", mudsys_do_save, METH_VARARGS,
+		     "save a character to disk");
+  PyMudSys_addMethod("do_quit", mudsys_do_quit, METH_VARARGS,
+		     "quit a character from game");
+  PyMudSys_addMethod("do_disconnect", mudsys_do_disconnect, METH_VARARGS,
+		     "disconnects a character from its socket");
+  PyMudSys_addMethod("add_cmd", mudsys_add_cmd, METH_VARARGS,
+		     "Add a new command to the game.");
+  PyMudSys_addMethod("remove_cmd", mudsys_remove_cmd, METH_VARARGS,
+		     "Removes a command from the game.");
+
+  Py_InitModule3("mudsys", makePyMethods(pymudsys_methods),
+		 "The mudsys module, for all MUD system utils.");
+}
diff -ruN ../nakedmudv3.1/src/scripts/pymudsys.h src/scripts/pymudsys.h
--- ../nakedmudv3.1/src/scripts/pymudsys.h	Wed Dec 31 17:00:00 1969
+++ src/scripts/pymudsys.h	Sat Jul  1 20:06:58 2006
@@ -0,0 +1,24 @@
+#ifndef __PYMUDSYS_H
+#define __PYMUDSYS_H
+//*****************************************************************************
+//
+// pymudsys.h
+//
+// A set of system level commands and variables that may be needed by python,
+// but which are not neccessarily needed by scripts.
+//
+//*****************************************************************************
+
+/* initialize mud sys module for use */
+PyMODINIT_FUNC
+init_PyMudSys(void);
+
+//
+// Adds a new method function (i.e. void *f) to the sys module. Name is the name
+// of the function, f is the PyCFunction implementing the new method, flags is
+// the type of method beings used (almost always METH_VARARGS), and doc is an
+// (optional) description of what the method does. For examples on how to add
+// new methods, see pymud.c
+void PyMudSys_addMethod(const char *name, void *f, int flags, const char *doc);
+
+#endif //__PYMUD_H
diff -ruN ../nakedmudv3.1/src/scripts/pyobj.c src/scripts/pyobj.c
--- ../nakedmudv3.1/src/scripts/pyobj.c	Sun Dec  4 20:03:07 2005
+++ src/scripts/pyobj.c	Sat Jul  1 20:06:58 2006
@@ -162,6 +162,13 @@
   else            return NULL;
 }
 
+
+PyObject *PyObj_get_weight_raw(PyObj *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
+  if(obj != NULL) return Py_BuildValue("d", objGetWeightRaw(obj));
+  else            return NULL;
+}
+
 PyObject *PyObj_getcontents(PyObj *self, PyObject *args) {
   OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
   if(obj == NULL) 
@@ -564,9 +571,19 @@
 
   // pull out the object and check the type
   OBJ_DATA    *obj = PyObj_AsObj((PyObject *)self);
-  if(obj != NULL)
-    return Py_BuildValue("i", 
-        objIsInstance(obj, get_fullkey_relative(type, get_script_locale())));
+  if(obj != NULL) {
+    PyObject *retval = NULL;
+    char     *locale = NULL;
+    if(get_script_locale())
+      locale = strdup(get_script_locale());
+    else
+      locale = strdup(get_key_locale(objGetClass(obj)));
+
+    retval = 
+      Py_BuildValue("i", objIsInstance(obj, get_fullkey_relative(type,locale)));
+    free(locale);
+    return retval;
+  }
   else {
     PyErr_Format(PyExc_StandardError, 
 		 "Tried to check instances of nonexistent object, %d.", self->uid);
@@ -1006,6 +1023,8 @@
     PyObj_addGetSetter("keywords", PyObj_getkeywords, PyObj_setkeywords,
 		       "the object's keywords");
     PyObj_addGetSetter("weight", PyObj_getweight, PyObj_setweight,
+		       "the object's weight (plus contents)");
+    PyObj_addGetSetter("weight_raw", PyObj_get_weight_raw, NULL,
 		       "the object's weight (minus contents)");
     PyObj_addGetSetter("uid", PyObj_getuid, NULL,
 		       "the object's unique identification number");
diff -ruN ../nakedmudv3.1/src/scripts/pyplugs.c src/scripts/pyplugs.c
--- ../nakedmudv3.1/src/scripts/pyplugs.c	Sun Dec  4 20:03:07 2005
+++ src/scripts/pyplugs.c	Sat Jul  1 20:06:58 2006
@@ -65,6 +65,27 @@
   }
   // no errors occured... load the module into our package
   else {
+    // we need to run an unload function if the module has been loaded before
+    PyObject *old_mod = PyImport_ImportModule(mname);
+    if(old_mod != NULL) {
+      PyObject *dict = PyModule_GetDict(old_mod);
+      
+      // if the module has an __unload__ function, call it
+      if(PyDict_GetItemString(dict, "__unload__") != NULL) {
+	PyObject *tbList = PyObject_CallMethod(old_mod, "__unload__", "");
+
+	// encountered an error with the unload function
+	if(tbList == NULL) {
+	  char *tb = getPythonTraceback();
+	  log_string("Encountered error in %s.__unload__():\r\n"
+		     "\r\nTraceback is:\r\n%s\r\n", mname, tb);
+	  free(tb);
+	}
+	Py_XDECREF(tbList);
+      }
+      Py_XDECREF(old_mod);
+    }
+
     PyObject *module = PyImport_ExecCodeModule(mname, code);
     if(module == NULL) {
       char *tb = getPythonTraceback();
diff -ruN ../nakedmudv3.1/src/scripts/pyroom.c src/scripts/pyroom.c
--- ../nakedmudv3.1/src/scripts/pyroom.c	Sun Dec  4 20:03:07 2005
+++ src/scripts/pyroom.c	Sat Jul  1 20:06:58 2006
@@ -28,6 +28,7 @@
 #include "pyobj.h"
 #include "pyexit.h"
 #include "pyroom.h"
+#include "pymud.h"
 
 
 
@@ -368,6 +369,42 @@
 
 
 //
+// Returns the direction of the exit
+PyObject *PyRoom_get_exit_dir(PyObject *self, PyObject *args) {
+  ROOM_DATA *room = NULL;
+  EXIT_DATA *exit = NULL;
+  PyObject  *pyex = NULL;
+
+  if (!PyArg_ParseTuple(args, "O", &pyex)) {
+    PyErr_Format(PyExc_TypeError, "Exit must be supplied.");
+    return NULL;
+  }
+
+  if((room = PyRoom_AsRoom((PyObject *)self)) == NULL) {
+    PyErr_Format(PyExc_TypeError, "Tried to get exit dir of nonexistent room"
+		 ", %d.", PyRoom_AsUid(self));
+    return NULL;
+  }
+
+  // get the exit
+  if(!PyExit_Check(pyex)) {
+    PyErr_Format(PyExc_TypeError, "an exit must be supplied to exdir");
+    return NULL;
+  }
+
+  // make sure the exit exists
+  exit = PyExit_AsExit(pyex);
+  if(exit == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to get direction of nonexistant "
+		 "exit, %d.", PyExit_AsUid(pyex));
+    return NULL;
+  }
+
+  return Py_BuildValue("s", roomGetExitDir(room, exit));
+}
+
+
+//
 // Fills an exit in the given direction
 PyObject *PyRoom_fill(PyRoom *self, PyObject *value) {
   ROOM_DATA *room = NULL;
@@ -425,7 +462,7 @@
 
   // make sure we have a valid destination
   if(PyString_Check(py_dest))
-    dest = get_fullkey(PyString_AsString(py_dest), get_script_locale());
+    dest = get_fullkey_relative(PyString_AsString(py_dest),get_script_locale());
   else if(PyRoom_Check(py_dest)) {
     ROOM_DATA *to_room = PyRoom_AsRoom(py_dest);
     if(to_room != NULL)
@@ -463,9 +500,9 @@
     roomSetExit(room, cdir, exit);
 
     // if we're digging a special exit, add a cmd for it to the room cmd table
-    if(dir_num == DIR_NONE && dir_abbrev_num == DIR_NONE)
+    if(get_cmd_move() && dir_num == DIR_NONE && dir_abbrev_num == DIR_NONE)
       nearMapPut(roomGetCmdTable(room), cdir, NULL,
-		 newCmd(cdir, cmd_move, POS_STANDING, POS_FLYING, 
+		 newPyCmd(cdir, get_cmd_move(), POS_STANDING, POS_FLYING, 
 			"player", TRUE, TRUE));
   }
 
@@ -721,6 +758,8 @@
 		     "fills in direction for the room.");
     PyRoom_addMethod("exit", PyRoom_get_exit, METH_VARARGS,
 		     "gets an exit in the room with the given direction name.");
+    PyRoom_addMethod("exdir", PyRoom_get_exit_dir, METH_VARARGS,
+		     "returns the direction of the exit.");
     PyRoom_addMethod("send", PyRoom_send, METH_VARARGS,
 		     "send a message to everyone in the room.");
     PyRoom_addMethod("edesc", PyRoom_edesc, METH_VARARGS,
diff -ruN ../nakedmudv3.1/src/scripts/scripts.c src/scripts/scripts.c
--- ../nakedmudv3.1/src/scripts/scripts.c	Sun Dec  4 20:39:05 2005
+++ src/scripts/scripts.c	Sat Jul  1 20:06:58 2006
@@ -31,6 +31,8 @@
 #include "pyexit.h"
 #include "pyobj.h"
 #include "pymud.h"
+#include "pymudsys.h"
+#include "pyhooks.h"
 #include "pyevent.h"
 #include "pystorage.h"
 #include "pyauxiliary.h"
@@ -125,39 +127,55 @@
 // a local variable used for storing whether or not the last script ran fine
 bool script_ok = TRUE;
 
-void expand_char_dynamic_descs(BUFFER *desc, CHAR_DATA *me, CHAR_DATA *ch) {
+void expand_char_dynamic_descs(const char *info) {
+  CHAR_DATA *me = NULL;
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &me, &ch);
+
   // if we're an NPC, do some special work for displaying us. We don't do 
   // dynamic descs for PCs because they will probably be describing themselves,
   // and we don't want to give them access to the scripting language.
   if(charIsNPC(me)) {
     PyObject *pyme = charGetPyForm(me);
     char   *locale = strdup(get_key_locale(charGetClass(me))); 
-    expand_dynamic_descs(desc, pyme, ch, locale);
+    expand_dynamic_descs(charGetLookBuffer(ch), pyme, ch, locale);
     Py_DECREF(pyme);
     free(locale);
   }
 }
 
-void  expand_obj_dynamic_descs(BUFFER *desc, OBJ_DATA *me, CHAR_DATA *ch) {
+void  expand_obj_dynamic_descs(const char *info) {
+  OBJ_DATA  *me = NULL;
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &me, &ch);
+
   PyObject *pyme = objGetPyForm(me);
   char   *locale = strdup(get_key_locale(objGetClass(me))); 
-  expand_dynamic_descs(desc, pyme, ch, locale);
+  expand_dynamic_descs(charGetLookBuffer(ch), pyme, ch, locale);
   Py_DECREF(pyme);
   free(locale);
 }
 
-void expand_room_dynamic_descs(BUFFER *desc, ROOM_DATA *me, CHAR_DATA *ch) {
+void expand_room_dynamic_descs(const char *info) {
+  ROOM_DATA *me = NULL;
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &me, &ch);
+
   PyObject *pyme = roomGetPyForm(me);
   char   *locale = strdup(get_key_locale(roomGetClass(me))); 
-  expand_dynamic_descs(desc, pyme, ch, locale);
+  expand_dynamic_descs(charGetLookBuffer(ch), pyme, ch, locale);
   Py_DECREF(pyme);
   free(locale);
 }
 
-void expand_exit_dynamic_descs(BUFFER *desc, EXIT_DATA *me, CHAR_DATA *ch) {
+void expand_exit_dynamic_descs(const char *info) {
+  EXIT_DATA *me = NULL;
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &me, &ch);
+
   PyObject *pyme = newPyExit(me);
   char   *locale = strdup(get_key_locale(roomGetClass(exitGetRoom(me)))); 
-  expand_dynamic_descs(desc, pyme, ch, locale);
+  expand_dynamic_descs(charGetLookBuffer(ch), pyme, ch, locale);
   Py_DECREF(pyme);
   free(locale);
 }
@@ -166,6 +184,10 @@
   Py_Finalize();
 }
 
+void finalize_scripts_hook(const char *info) {
+  finalize_scripts();
+}
+
 
 
 //*****************************************************************************
@@ -312,6 +334,7 @@
   Py_Initialize();
 
   // initialize all of our modules written in C
+  init_PyMudSys();
   init_PyAuxiliary();
   init_PyEvent();
   init_PyStorage();
@@ -320,6 +343,7 @@
   init_PyExit();
   init_PyObj();
   init_PyMud();
+  init_PyHooks();
 
   // initialize all of our modules written in Python
   init_pyplugs();
@@ -345,7 +369,7 @@
   hookAdd("preprocess_char_desc", expand_char_dynamic_descs);
   hookAdd("preprocess_obj_desc",  expand_obj_dynamic_descs);
   hookAdd("preprocess_exit_desc", expand_exit_dynamic_descs);
-  hookAdd("shutdown",             finalize_scripts);
+  hookAdd("shutdown", finalize_scripts_hook);
 
   /*
   // add new player commands
@@ -769,6 +793,19 @@
   PyObject *pyform = roomGetPyFormBorrowed(room);
   Py_INCREF(pyform);
   return pyform;
+}
+
+PyObject *PyList_fromList(LIST *list, void *convertor) {
+  PyObject *pylist = PyList_New(0);
+  PyObject *(*conv_func)(void *) = convertor; 
+  LIST_ITERATOR *list_i = newListIterator(list);
+  void            *elem = NULL;
+  ITERATE_LIST(elem, list_i) {
+    PyObject *pyelem = conv_func(elem);
+    PyList_Append(pylist, pyelem);
+    Py_DECREF(pyelem);
+  } deleteListIterator(list_i);
+  return pylist;
 }
 
 void triggerListAdd(LIST *list, const char *trigger) {
diff -ruN ../nakedmudv3.1/src/scripts/scripts.h src/scripts/scripts.h
--- ../nakedmudv3.1/src/scripts/scripts.h	Sun Dec  4 20:39:05 2005
+++ src/scripts/scripts.h	Sat Jul  1 20:06:58 2006
@@ -97,6 +97,10 @@
 PyObject  *objGetPyFormBorrowed(OBJ_DATA  *obj);
 
 //
+// returns a Python form of the given list
+PyObject *PyList_fromList(LIST *list, void *convertor);
+
+//
 // adds a trigger to the trigger list. Makes sure it's not a duplicate copy
 void triggerListAdd(LIST *list, const char *trigger);
 
diff -ruN ../nakedmudv3.1/src/scripts/trighooks.c src/scripts/trighooks.c
--- ../nakedmudv3.1/src/scripts/trighooks.c	Sun Dec  4 20:03:07 2005
+++ src/scripts/trighooks.c	Sat Jul  1 20:06:58 2006
@@ -285,23 +285,40 @@
 //*****************************************************************************
 // trighooks
 //*****************************************************************************
-void do_give_trighooks(CHAR_DATA *ch, CHAR_DATA *recv, OBJ_DATA *obj) {
+void do_give_trighooks(const char *info) {
+  CHAR_DATA   *ch = NULL;
+  CHAR_DATA *recv = NULL;
+  OBJ_DATA   *obj = NULL;
+  hookParseInfo(info, &ch, &recv, &obj);
+
   do_char_trigs(ch,   "give",    recv, obj);
   do_char_trigs(recv, "receive", ch,   obj);
   do_obj_trigs (obj,  "give",    ch,  recv);
 }
 
-void do_get_trighooks(CHAR_DATA *ch, OBJ_DATA *obj) {
+void do_get_trighooks(const char *info) {
+  CHAR_DATA *ch = NULL;
+  OBJ_DATA *obj = NULL;
+  hookParseInfo(info, &ch, &obj);
+
   do_obj_trigs (obj,             "get", ch, NULL);
   do_room_trigs(charGetRoom(ch), "get", ch, obj);
 }
 
-void do_drop_trighooks(CHAR_DATA *ch, OBJ_DATA *obj) {
+void do_drop_trighooks(const char *info) {
+  CHAR_DATA *ch = NULL;
+  OBJ_DATA *obj = NULL;
+  hookParseInfo(info, &ch, &obj);
+
   do_obj_trigs (obj,             "drop", ch, NULL);
   do_room_trigs(charGetRoom(ch), "drop", ch,  obj);
 }
 
-void do_enter_trighooks(CHAR_DATA *ch, ROOM_DATA *room) {
+void do_enter_trighooks(const char *info) {
+  CHAR_DATA   *ch = NULL;
+  ROOM_DATA *room = NULL;
+  hookParseInfo(info, &ch, &room);
+
   LIST_ITERATOR *mob_i = newListIterator(roomGetCharacters(room));
   CHAR_DATA       *mob = NULL;
   ITERATE_LIST(mob, mob_i) {
@@ -311,7 +328,12 @@
   do_room_trigs(room, "enter", ch, NULL);
 }
 
-void do_exit_trighooks(CHAR_DATA *ch, ROOM_DATA *room, EXIT_DATA *exit) {
+void do_exit_trighooks(const char *info) {
+  CHAR_DATA   *ch = NULL;
+  ROOM_DATA *room = NULL;
+  EXIT_DATA *exit = NULL;
+  hookParseInfo(info, &ch, &room, &exit);
+
   LIST_ITERATOR *mob_i = newListIterator(roomGetCharacters(room));
   CHAR_DATA       *mob = NULL;
   ITERATE_LIST(mob, mob_i) {
@@ -322,11 +344,20 @@
   do_char_trigs(ch,   "move", exit, NULL);
 }
 
-void do_ask_trighooks(CHAR_DATA *ch, CHAR_DATA *listener, char *speech) {
+void do_ask_trighooks(const char *info) {
+  CHAR_DATA       *ch = NULL;
+  CHAR_DATA *listener = NULL;
+  char        *speech = NULL;
+  hookParseInfo(info, &ch, &listener, &speech);
   do_char_trigs(listener, "speech", ch, speech);
+  if(speech) free(speech);
 }
 
-void do_say_trighooks(CHAR_DATA *ch, char *speech) {
+void do_say_trighooks(const char *info) {
+  CHAR_DATA *ch = NULL;
+  char  *speech = NULL;
+  hookParseInfo(info, &ch, &speech);
+
   LIST_ITERATOR *mob_i = newListIterator(roomGetCharacters(charGetRoom(ch)));
   CHAR_DATA       *mob = NULL;
   ITERATE_LIST(mob, mob_i) {
@@ -334,23 +365,41 @@
       do_char_trigs(mob, "speech", ch, speech);
   } deleteListIterator(mob_i);
   do_room_trigs(charGetRoom(ch), "speech", ch, speech);
+  if(speech) free(speech);
 }
 
-void do_greet_trighooks(CHAR_DATA *ch, CHAR_DATA *greeted) {
+void do_greet_trighooks(const char *info) {
+  CHAR_DATA      *ch = NULL;
+  CHAR_DATA *greeted = NULL;
+  hookParseInfo(info, &ch, &greeted);
   do_char_trigs(greeted, "greet", ch, NULL);
 }
 
-void do_wear_trighooks(CHAR_DATA *ch, OBJ_DATA *obj) {
+void do_wear_trighooks(const char *info) {
+  CHAR_DATA *ch = NULL;
+  OBJ_DATA *obj = NULL;
+  hookParseInfo(info, &ch, &obj);
+  printf("%s\r\n", info);
+  printf("%s %s\r\n", charGetName(ch), objGetName(obj));
+
   do_char_trigs(ch,  "wear", obj, NULL);
   do_obj_trigs (obj, "wear", ch,  NULL);
 }
 
-void do_remove_trighooks(CHAR_DATA *ch, OBJ_DATA *obj) {
+void do_remove_trighooks(const char *info) {
+  CHAR_DATA *ch = NULL;
+  OBJ_DATA *obj = NULL;
+  hookParseInfo(info, &ch, &obj);
   do_char_trigs(ch,  "remove", obj, NULL);
   do_obj_trigs (obj, "remove", ch,  NULL);
 }
 
-void do_reset_trighooks(ZONE_DATA *zone) {
+void do_reset_trighooks(const char *info) {
+  char  *zone_key = NULL;
+  hookParseInfo(info, &zone_key);
+  ZONE_DATA *zone = worldGetZone(gameworld, zone_key);
+  free(zone_key);
+
   LIST_ITERATOR *res_i = newListIterator(zoneGetResettable(zone));
   char           *name = NULL;
   const char   *locale = zoneGetKey(zone);
@@ -361,11 +410,17 @@
   } deleteListIterator(res_i);
 }
 
-void do_open_door_trighooks(CHAR_DATA *ch, EXIT_DATA *ex) {
+void do_open_door_trighooks(const char *info) {
+  CHAR_DATA *ch = NULL;
+  EXIT_DATA *ex = NULL;
+  hookParseInfo(info, &ch, &ex);
   do_room_trigs(charGetRoom(ch), "open", ch, ex);
 }
 
-void do_open_obj_trighooks(CHAR_DATA *ch, OBJ_DATA *obj) {
+void do_open_obj_trighooks(const char *info) {
+  CHAR_DATA *ch = NULL;
+  OBJ_DATA *obj = NULL;
+  hookParseInfo(info, &ch, &obj);
   do_obj_trigs(obj, "open", ch, NULL);
 }
 
diff -ruN ../nakedmudv3.1/src/socket.c src/socket.c
--- ../nakedmudv3.1/src/socket.c	Sun Dec  4 20:03:08 2005
+++ src/socket.c	Sat Jul  1 20:06:58 2006
@@ -1114,7 +1114,7 @@
 }
 
 
-void do_copyover(CHAR_DATA *ch) {
+void do_copyover(void) {
   LIST_ITERATOR *sock_i = newListIterator(socket_list);
   SOCKET_DATA     *sock = NULL;
   FILE *fp;
@@ -1122,16 +1122,11 @@
   char control_buf[20];
   char port_buf[20];
 
-  if ((fp = fopen(COPYOVER_FILE, "w+")) == NULL) {
-    text_to_char(ch, "Copyover file not writeable, aborted.\n\r");
+  if ((fp = fopen(COPYOVER_FILE, "w+")) == NULL)
     return;
-  }
 
   sprintf(buf, "\n\r <*>            The world starts spinning             <*>\n\r");
 
-  // execute our shutdown hooks
-  hookRun("shutdown");
-
   // For each playing descriptor, save its character and account
   ITERATE_LIST(sock, sock_i) {
     compressEnd(sock, sock->compressing, FALSE);
@@ -1158,13 +1153,15 @@
   // close any pending sockets
   recycle_sockets();
 
+#ifdef MODULE_WEBSERVER
+  // if we have a webserver set up, finalize that
+  finalize_webserver();
+#endif
+  
   // exec - descriptors are inherited
   sprintf(control_buf, "%d", control);
   sprintf(port_buf, "%d", mudport);
   execl(EXE_FILE, "NakedMud", "-copyover", control_buf, port_buf, NULL);
-
-  // Failed - sucessful exec will not return
-  text_to_char(ch, "Copyover FAILED!\n\r");
 }
 
 
diff -ruN ../nakedmudv3.1/src/socket.h src/socket.h
--- ../nakedmudv3.1/src/socket.h	Sun Dec  4 20:03:08 2005
+++ src/socket.h	Sat Jul  1 20:06:58 2006
@@ -12,7 +12,7 @@
 bool  read_from_socket      ( SOCKET_DATA *dsock );
 void  socket_handler        ( void );
 void  copyover_recover      ( void );
-void  do_copyover           ( CHAR_DATA *ch);
+void  do_copyover           ( void );
 
 /* sends the output directly */
 bool  text_to_socket        ( SOCKET_DATA *dsock, const char *txt );
diff -ruN ../nakedmudv3.1/src/time/time.c src/time/time.c
--- ../nakedmudv3.1/src/time/time.c	Sun Dec  4 20:03:07 2005
+++ src/time/time.c	Sat Jul  1 20:06:58 2006
@@ -222,12 +222,16 @@
 
 //
 // If it's in the night, swap out our desc for the room's night desc
-void room_nightdesc_hook(BUFFER *desc, ROOM_DATA *room, CHAR_DATA *looker) {
+void room_nightdesc_hook(const char *info) {
+  ROOM_DATA   *room = NULL;
+  CHAR_DATA *looker = NULL;
+  hookParseInfo(info, &room, &looker);
+
   if((is_evening() || is_night()) && *roomGetNightDesc(room)) {
     // if it's the room desc and not an edesc, cat the night desc...
-    if(!strcasecmp(bufferString(desc), roomGetDesc(room))) {
-      bufferClear(desc);
-      bufferCat(desc, roomGetNightDesc(room));
+    if(!strcasecmp(bufferString(charGetLookBuffer(looker)),roomGetDesc(room))) {
+      bufferClear(charGetLookBuffer(looker));
+      bufferCat(charGetLookBuffer(looker), roomGetNightDesc(room));
     }
   }
 }
diff -ruN ../nakedmudv3.1/src/utils.c src/utils.c
--- ../nakedmudv3.1/src/utils.c	Sun Dec  4 20:03:08 2005
+++ src/utils.c	Sat Jul  1 20:06:58 2006
@@ -1220,6 +1220,16 @@
   return data;
 }
 
+LIST *reverse_list(LIST *list) {
+  LIST         *newlist = newList();
+  LIST_ITERATOR *list_i = newListIterator(list);
+  void            *elem = NULL;
+  ITERATE_LIST(elem, list_i) {
+    listPut(newlist, elem);
+  } deleteListIterator(list_i);
+  return newlist;
+}
+
 bool parse_worldkey(const char *key, char *name, char *locale) {
   *name = *locale = '\0';
   int pos = next_letter_in(key, '@');
diff -ruN ../nakedmudv3.1/src/utils.h src/utils.h
--- ../nakedmudv3.1/src/utils.h	Sun Dec  4 20:03:08 2005
+++ src/utils.h	Sat Jul  1 20:06:58 2006
@@ -219,6 +219,10 @@
 void *identity_func(void *data);
 
 //
+// returns a copy of the list with everything in reverse order
+LIST *reverse_list(LIST *list);
+
+//
 // checks to see if a file or directory exists
 bool file_exists(const char *fname);
 bool dir_exists (const char *dname);
diff -ruN ../nakedmudv3.1/src/zone.c src/zone.c
--- ../nakedmudv3.1/src/zone.c	Sun Dec  4 20:03:08 2005
+++ src/zone.c	Sat Jul  1 20:06:58 2006
@@ -124,7 +124,7 @@
   zone->pulse--;
   if(zone->pulse == 0) {
     zone->pulse = zone->pulse_timer;
-    hookRun("reset", zone);
+    hookRun("reset", hookBuildInfo("str", zoneGetKey(zone)));
   }
 }
 
